<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.wikimedia</groupId>
        <artifactId>wmf-jvm-parent-pom</artifactId>
        <version>1.74</version>
    </parent>

    <groupId>org.wikimedia.search</groupId>
    <artifactId>mjolnir</artifactId>
    <version>2.1-SNAPSHOT</version>
    <packaging>jar</packaging>

    <scm>
        <connection>scm:git:https://gitlab.wikimedia.org/repos/search-platform/mjolnir.git</connection>
        <developerConnection>scm:git:ssh://git@gitlab.wikimedia.org/repos/search-platform/mjolnir.git</developerConnection>
        <tag>HEAD</tag>
        <url>https://gitlab.wikimedia.org/repos/search-platform/mjolnir</url>
    </scm>
    <properties>
        <scala.compat.version>2.12</scala.compat.version>
        <scala.version>2.12.18</scala.version>
        <spark.version>3.1.2</spark.version>
        <semanticdb.version>4.9.5</semanticdb.version>
    </properties>

    <dependencies>
        <dependency>
            <groupId>de.thetaphi</groupId>
            <artifactId>forbiddenapis</artifactId>
            <scope>provided</scope>
            <optional>true</optional>
        </dependency>
        <dependency>
            <groupId>org.apache.spark</groupId>
            <artifactId>spark-mllib_${scala.compat.version}</artifactId>
            <version>${spark.version}</version>
            <scope>provided</scope>
            <exclusions>
                <exclusion>
                    <groupId>jakarta.xml.bind</groupId>
                    <artifactId>jakarta.xml.bind-api</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <dependency>
            <groupId>org.scala-lang</groupId>
            <artifactId>scala-compiler</artifactId>
            <version>${scala.version}</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>org.scala-lang</groupId>
            <artifactId>scala-library</artifactId>
            <version>${scala.version}</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>org.scala-lang</groupId>
            <artifactId>scala-reflect</artifactId>
            <version>${scala.version}</version>
            <scope>provided</scope>
        </dependency>
        <!-- Used to read same format as python clickmodels when comparing results -->
        <dependency>
            <groupId>com.fasterxml.jackson.module</groupId>
            <artifactId>jackson-module-scala_${scala.compat.version}</artifactId>
            <version>2.14.2</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.scalatest</groupId>
            <artifactId>scalatest_${scala.compat.version}</artifactId>
            <version>3.0.1</version>
            <scope>test</scope>
        </dependency>
    </dependencies>

    <build>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.basepom.maven</groupId>
                    <artifactId>duplicate-finder-maven-plugin</artifactId>
                    <configuration>
                        <ignoredResourcePatterns>
                            <ignoredResourcePattern>git.properties</ignoredResourcePattern>
                            <ignoredResourcePattern>rootdoc.txt</ignoredResourcePattern>
                        </ignoredResourcePatterns>
                        <ignoredClassPatterns>
                            <ignoredClassPattern>org.apache.spark.unused.UnusedStubClass</ignoredClassPattern>
                        </ignoredClassPatterns>
                    </configuration>
                </plugin>
            </plugins>
        </pluginManagement>
        <plugins>
            <plugin>
                <groupId>net.alchim31.maven</groupId>
                <artifactId>scala-maven-plugin</artifactId>
            </plugin>
            <plugin>
                <groupId>de.thetaphi</groupId>
                <artifactId>forbiddenapis</artifactId>
                <configuration>
                    <excludes>
                        <!--
                            FIXME: For some reason, the usual @SuppressForbidden annotation
                            does not seem to work. Ideally we would investigate and fix,
                            but for a single violate, this is good enough for now.
                        -->
                        <exclude>org/wikimedia/search/mjolnir/DBNSuite.class</exclude>
                    </excludes>
                </configuration>
            </plugin>
        </plugins>
    </build>
</project>
